package com.ningdatech.pmapi.projectdeclared.entity.dto;

import com.ningdatech.pmapi.projectlib.model.entity.Project;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.Map;

/**
 * @Classname DeclaredProjectDto
 * @Description 申报项目
 * @Date 2023/2/1 14:52
 * @Author PoffyZhang
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class DeclaredProjectDto implements Serializable {

    @NotNull
    private Project projectInfo;

    private Map<String,Object> formData;

    @NotBlank
    private String regionCode;
}
