package com.ningdatech.pmapi.todocenter.bean.vo;

import com.ningdatech.pmapi.common.model.FileBasicInfo;
import com.ningdatech.pmapi.projectlib.model.entity.Project;
import com.ningdatech.pmapi.todocenter.bean.entity.ProgressNode;
import com.ningdatech.pmapi.user.entity.UserInfo;
import com.wflow.workflow.bean.process.OrgUser;
import com.wflow.workflow.bean.process.form.Form;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 流程进展详情实体
 *
 * @author CMM
 * @since 2023/01/30 17:21
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class ProcessProgressDetailVo {
    /**
     * 审批实例ID
     */
    private String instanceId;
    /**
     * 表单配置项
     */
    private List<Form> formItems;
    /**
     * 表单值
     */
    private Map<String, Object> formData;
    /**
     * 流程进度步骤
     */
    private List<ProgressNode> progress;
    /**
     * 流程定义名称
     */
    private String processDefName;
    /**
     * 版本
     */
    private Integer version;
    /**
     * 流程状态
     */
    private String status;
    /**
     * 流程结果
     */
    private String result;
    /**
     * 发起人
     */
    private OrgUser startTempUser;
    /**
     * 发起人
     */
    private UserInfo startUser;
    /**
     * 发起人部门
     */
    private String startDept;
    /**
     * 发起时间
     */
    private Date startTime;
    /**
     * 项目申报信息
     */
    private Project declaredProjectInfo;
}
