package com.ningdatech.pmapi.user.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 用户信息表
 * </p>
 *
 * @author Liuxinxin
 * @since 2023-01-04
 */
@Data
@TableName("nd_user_info")
@ApiModel(value = "UserInfo对象", description = "用户信息表")
public class UserInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    @ApiModelProperty("创建时间")
    private LocalDateTime createOn;

    @ApiModelProperty("最后修改时间")
    private LocalDateTime updateOn;

    @ApiModelProperty("创建人")
    private Long createBy;

    @ApiModelProperty("最后修改人")
    private Long updateBy;

    @ApiModelProperty("用户名（登陆账号）")
    private String username;

    @ApiModelProperty("手机")
    private String mobile;

    @ApiModelProperty("用户真实姓名")
    private String realName;

    @ApiModelProperty("所属公司id")
    private Long companyId;

    @ApiModelProperty("所属公司名称")
    private String companyName;

    @ApiModelProperty("用户角色")
    private String role;

    @ApiModelProperty("区域id")
    private Long regionCode;

    @ApiModelProperty("头像文件id")
    private Long avatarFileId;

    @ApiModelProperty("所负责的公司id列表")
    private String manageCompanyIds;

    @ApiModelProperty("是否删除")
    private Boolean deleted;

    @ApiModelProperty("身份证号")
    private String idCard;

}
